/*
 *  SingIt Lyrics Displayer
 *  Copyright (C) 2000 - 2002 Jan-Marek Glogowski <glogow@stud.fbi.fh-darmstadt.de>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef __TIMEOUT_H__
#define __TIMEOUT_H__

#include <glib.h>

typedef struct {

	guint timeoutId;
	guint attachments;

} GuardedTimeout;

/* creates new config data includes attachment */
GuardedTimeout* guarded_timeout_new(guint interval, GSourceFunc function, gpointer data);

/* frees config data even if there are attachments */
void guarded_timeout_free(GuardedTimeout *timeout);

/* attach to a timeout */
/* result == attach succeed ? TRUE : FALSE */
inline gboolean guarded_timeout_attach(GuardedTimeout *timeout);
/* detach your timeout- free it if there are no more attachments */
/* result == freed ? TRUE : FALSE */
inline gboolean guarded_timeout_detach(GuardedTimeout *timeout, gboolean free);

#endif  // __TIMEOUT_H__
